unit Clock;
interface
uses
   Objects,
   Common, GraphFns,
   Windows;

type
   TClockWindow =
   object(TWindow)

      constructor Init(Ax, Ay, Aw, Ah  :Integer);

      procedure Draw; virtual;
   end;

implementation
uses
   Copy;

{$L clock}
procedure _Clock; external;

const
   CharWidth =     12;
   CharHeight =    14;
   CharSpace =     CharWidth+3;
   CharSWidth =    4;
   CharSSpace =    CharSWidth+3;

procedure OutChar(x, y, Id             :Integer); assembler;
asm
   push ds
   cld
   mov  es,word ptr BufferPtr+2
   imul di,y,320
   add  di,x
   push seg _Clock
   pop  ds
   imul si,Id,CharWidth*CharHeight
   add  si,offset _Clock +8
   mov  dx,CharHeight
@@Y:
   mov  cx,CharWidth
@@X:
   lodsb
   cmp  al,255
   jne  @@Draw
   inc  di
   loop @@X
   jmp  @@Done
@@Draw:
   stosb
   loop @@X
@@Done:
   add  di,320-CharWidth
   dec  dx
   jnz  @@Y
   pop  ds
end;

constructor TClockWindow.Init;
begin
   if Initialized then Exit;
   Inherited Init(Ax, Ay, Aw, Ah, 'Clock', nil, CopyArea, nil, nil, False);
end;

procedure TClockWindow.Draw;
var
   SaveBuffer      :Pointer;
   cn, cx, cy      :Integer;
   Time            :Word;
   Digit           :Byte;
const
   Divs            :Array [0..5] of Byte =
   (10, 10, 10, 6, 10, 6);
begin
   if not Initialized then Exit;

   SaveBuffer:=BufferPtr; BufferPtr:=FinalBuffer;
   DrawWindow(x, y, w, h, Title^);

   Time:=LongDiv(LongMul(Timer-StartTimer, 1000), 182);
   cx:=x+3+(w+CharSpace*5+CharSSpace*2+CharWidth) shr 1;
   cy:=y+4+(h-CharHeight) shr 1;
   for cn:=0 to 5 do
   begin
      asm
         mov  ax,Time
         cwd
         mov  bx,cn
         xor  cx,cx
         mov  cl,byte ptr Divs[bx]
         div  cx
         mov  Digit,dl
         mov  Time,ax
      end;
      if (cn=2) or (cn=4) then
      begin
         Dec(cx, CharSSpace);
         OutChar(cx, cy, 12-(cn shr 1));
      end;
      Dec(cx, CharSpace);
      OutChar(cx, cy, Digit);
   end;

   BufferPtr:=SaveBuffer;
end;

end.
