unit Fire;
interface
uses
   Objects;

type
   TFire =
   object(TObject)
      x, y, w, h,
      t            :Integer;
      Root         :PByteArray;

      constructor Init(Ax, Ay, Aw, Ah  :Integer);

      procedure Draw;
   end;

implementation
uses
   Common, Startup;

const
   NColor =        FCCount-1;
   MinColor =      FCStart;
   MaxColor =      MinColor+NColor;

{$L fire}
procedure FireLine(x, y, w, Rnd, Buffer          :Word); external;
procedure CopyFire(x, y, w, h, S, T              :Word); external;

{ TFire }

constructor TFire.Init;
begin
   x:=Ax; y:=Ay; w:=Aw; h:=Ah; t:=Ay-Ah;
   Root:=Ptr(PtrRec(FireBuffer).Seg, Word(Ay)*320+Word(Ax));
end;

procedure TFire.Draw;
var
   cx, cy, sx      :Integer;
begin
   if x=0 then Exit;

   sx:=w shr 4;

   for cx:=sx to w-sx do
      Root^[cx]:=MaxColor-Random(NColor shr 2);

   for cx:=0 to sx-1 do
   begin
      Root^[cx]:=MinColor; Root^[w-cx]:=MinColor;
   end;

   for cy:=t to y do
      FireLine(x+Random(3)-1, cy, w, Random($FFFF), PtrRec(FireBuffer).Seg);

   CopyFire(x, t, w+1, h+1, PtrRec(FireBuffer).Seg, PtrRec(BufferPtr).Seg);
end;

end.
