unit Startup;
interface
uses
   Objects,
   Ints,
   GRect, General,
   MousePtr, Fade, GraphFns, Backgnd, Windows,
   Common, Tables,
   Smooth, Scale;

procedure InitIntro;
procedure DoneIntro;
function  Stop     :Boolean;

const
   MsgCPU          :PChar =
   'At least an 80386 CPU is required'#13#10'$';

   MsgVideo        :PChar =
   'At least a VGA adapter is required'#13#10'$';

   MousePresent    :Boolean =          False;

type
   TShiftX =       Array [0..199] of ShortInt;
   TShiftY =       Array [0..319] of ShortInt;
   TShiftYOfs =    Array [0..319] of Integer;

var
   ShiftX          :TShiftX;
   ShiftY          :TShiftY;
   ShiftYOfs       :TShiftYOfs;

procedure _Mouse;
procedure _Plate;
procedure _Stove;

const
   Mouse           :PGPoint=@_Mouse;

var
   MouseS          :PGPoint;

const
   FCStart =       204;
   FCCount =       20;
   FCEnd =         FCStart+FCCount-1;

   RndPalMin =     10;
   RndPalMax =     40;

implementation
uses
   Morphing;

var
   RndPalette      :^TPalette;

{$L mouse}
procedure _Mouse; external;

{$L plate}
procedure _Plate; external;

{$L stove}
procedure _Stove; external;

procedure CheckReq;
var
   TestVGA         :Byte;
begin
   if Test8086<2 then
   begin
      asm
         mov  dx,word ptr MsgCPU
         mov  ah,9
         int  21h
      end;
      Halt;
   end;

   asm
      mov  ax,1A00h
      int  10h
      mov  TestVGA,al
   end;
   if TestVGA<>$1A then
   begin
      asm
         mov  dx,word ptr MsgVideo
         mov  ah,9
         int  21h
      end;
      Halt;
   end;
end;

procedure InitVideo;
begin
   asm
      mov  ax,13h
      int  10h

      xor  bx,bx
      mov  cx,100h
      les  dx,Palette
      mov  ax,1012h
      int  10h

      mov  ax,3533h
      int  21h
      mov  ax,es
      or   ax,bx
      jz   @@NoMouse
      xor  ax,ax
      int  33h
      mov  MousePresent,ah
@@NoMouse:
   end;
end;

procedure InitMemory;
begin
   BackPtr:=HeapOrg;
   asm
      add  word ptr HeapOrg+2,1000h
   end;

   BufferPtr:=HeapOrg;
   asm
      add  word ptr HeapOrg+2,1000h
   end;

   FireBuffer:=HeapOrg;
   asm
      add  word ptr HeapOrg+2,1000h
   end;

   FillChar(FireBuffer^, 320*200, FCStart);

   FinalBuffer:=HeapOrg;
   asm
      add  word ptr HeapOrg+2,1000h
   end;

   MouseS:=HeapOrg;
   asm
      mov  ax,word ptr cs:_Mouse
      inc  ax
      mul  word ptr cs:_Mouse+2
      shr  ax,4
      add  word ptr HeapOrg+2,ax
   end;
end;

procedure InitMorph;
begin
   FillChar(ShiftX, SizeOf(ShiftX)+SizeOf(ShiftY), 0);
end;

procedure ScaleMouse(SizeX, SizeY      :Integer);
var
   NewSize         :TGPoint;
begin
   NewSize.X:=SizeX; NewSize.Y:=SizeY;
   ScaleImage(Mouse, MouseS, NewSize);
end;

procedure RandomPalette(var P          :TPalette);
type
   TRGB =
   record
      R, G, B      :Byte;
   end;
var
   c, d            :Integer;
begin
   d:=1;
   for c:=FCStart to FCEnd do
   with TRGB(P[c]) do
   begin
      if c=FCStart then
      begin
         R:=RndPalMin+Random(RndPalMax-RndPalMin+1); G:=R; B:=R;
      end else
      begin
         R:=P[c-1, 0]+d*Random((RndPalMax-RndPalMin+1) shr 1);

         if Random(2)=0 then
         if Random((RndPalMin+RndPalMax) shr 1)>R then d:=1 else d:=-1;

         if (R<=RndPalMin) or (R>127) then
         begin
            R:=RndPalMin; d:=1;
         end else
         if R>=RndPalMax then
         begin
            R:=RndPalMax; d:=-1;
         end;

         G:=R; B:=R;
      end;
   end;
end;

procedure RandomPalette1; far;
begin
   RandomPalette(Palette^);
end;

procedure RandomPalette2; far;
begin
   RandomPalette(RndPalette^);
   SetPalette(RndPalette^);
end;

procedure ShowTitle;
var
   SaveBuffer      :Pointer;

procedure ShowRandom;
var
   x, y, c, d      :Integer;
begin
   c:=FCStart+Random(FCCount); d:=1;
   for y:=100-88+7+3 to 100-88+7+112-3 do
   for x:=160-80+3 to 160-80+2*80-3 do
   begin
      BufferPtr^[y, x]:=c;

      if c>=FCEnd then d:=-1;
      if c<=FCStart then d:=1;

      Inc(c, d);

      if (x+y) and 3=0 then
      if Random(4)=0 then asm neg d end;
   end;
end;

begin
   SaveBuffer:=BufferPtr; BufferPtr:=@VM;

   asm
      mov  dx,3C8h
      xor  ax,ax
      out  dx,al
      inc  dx
      mov  cx,768
@@Next:
      out  dx,al
      nop
      loop @@Next
   end;

   DrawFrame(160-87, 100-88, 2*87, 2*88, '');
   Bar(160-84, 100-85, 2*84+1, 2*85+1, 254);
   DrawFrame(160-80, 100-88+7, 2*80, 112, '');
   ShowRandom;
   ScaleMouse(150, 105);
   Morph(160, 76, MouseS, PtrRec(BufferPtr).Seg);
   ScaleMouse(30, 20);
   Morph(151, 150, MouseS, PtrRec(BufferPtr).Seg);
   OutText(166, 147, 253, 'TRO');
   OutTextC(160, 170, 255, '(C) 1995 by Solar Designer');

   ExtraTimer:=@RandomPalette1;
   ShowPalette;
   BufferPtr:=SaveBuffer;
end;

procedure InitBackground;
var
   i               :Integer;
begin
   DrawBackground;
   for i:=0 to 63 do
   begin
      ScaleMouse(32+Random(128), 20+Random(80));
      PutBlock(Random(320), Random(200), MouseS);
   end;
   OutTextC(160, 7, 255, '... MouseTRO ]I[ ... by Solar Designer ...');
end;

procedure InitIntro;
var
   SavePalette     :TPalette;
begin
   RndPalette:=@SavePalette;

   CheckReq;
   InitInts;
   InitVideo;
   Randomize;
   InitMemory;
   InitMorph;

   SavePalette:=Palette^;
   ShowTitle;
   asm cli end;
   Palette^:=SavePalette;
   ExtraTimer:=@RandomPalette2;
   asm sti end;

   LTimer:=Timer;

   CalcTables;

   InitBackground;
   Move(BufferPtr^, BackPtr^, 320*200);
   Move(BufferPtr^, FinalBuffer^, 320*200);

   ScaleMouse(74, 53);

   while Timer-LTimer<2*18 do;

   asm cli end;
   SavePalette:=Palette^;
   ExtraTimer:=@RandomPalette1;
   RandomPalette1;
   asm sti end;
   HidePalette;
   ExtraTimer:=@RETF;
   Palette^:=SavePalette;
   Move(FinalBuffer^, VM, 320*200);
   ShowPalette;
end;

procedure DoneIntro;
var
   HDiv            :Byte;
begin
   HideMouse;

   for HDiv:=2 to $1E do
   begin
      asm
         mov  al,9
         mov  ah,HDiv
         mov  dx,3D4h
         out  dx,ax
      end;

      LTimer:=Timer;
      while Timer=LTimer do;
   end;

   HidePalette;

   asm
      mov  ax,3
      int  10h
   end;

   DoneInts;
end;

function  Stop;
assembler;
asm
   mov  al,ScanCode
   cmp  al,1
   jne  @@NoKey
   ret
@@NoKey:
   mov  al,MousePresent
   or   al,al
   jz   @@NoMouse
   mov  ax,3
   int  33h
   xchg ax,bx
   and  al,2
@@NoMouse:
end;

end.
